class Parser(object):

 def __init__(self, text=""):
  self.reset()
  self.text = text

 def reset(self):
  self.offset = 0
  self.open = '[['
  self.close = ']]'

 def read_until(self, chars):
  location = self.text.find(chars, self.offset)
  if location == -1:
   s = self.text[offset:]
   self.offset += len(s)
   return s
  else:
   s = self.text[self.offset:location]
   self.offset += len(s)
   return s

 def read_command(self):
  self.offset += len(self.open)
  command = self.read_until(self.close)
  if self.offset+len(self.close) <= len(self.text):
   self.offset += len(self.close)
  command = command.split(' ', 1)
  if len(command) == 1: command.append('')
  return (command[0], command[1])

 def read_remaining(self):
  s = self.text[self.offset:]
  self.offset = len(self.text) - 1
  return s

 def parse(self, to_parse):
  self.reset()
  self.text = to_parse
  if self.open not in to_parse:
   return [to_parse]
  result = []
  while self.text.find(self.open, self.offset) != -1:
   r = self.read_until(self.open)
   if r:
    result.append(r)
   result.append(self.read_command())
  remaining = self.read_remaining()
  if remaining:
   result.append(remaining)
  return result
